<template>
  <transition :name="animation">
    <pageWrapper
      v-if="show"
      :title="title"
      :backable="navs"
      :closable="navs"
      @close="closeAll"
      @back="close"
      :gradient="true"
      :class="!controls ? 'full' : ''">
      <template slot="titleAppend">
        <info>
          {{$t('pincode.help')}}
        </info>
      </template>
      <div class="pinPad_panel">
        <PinCode
          @change="onChange"
          :error="hasError"
          ref="pincode"></PinCode>
        <div
          class="pinPad_panel-footer"
          v-if="controls">
          <Btn
            transparent
            :disabled="needToReenter"
            @click="skip">{{$t('pincode.skip')}}
          </Btn>
          <Btn
            :disabled="disabled"
            @click="submit">{{needToReenter ? $t('pincode.check') : $t('pincode.set')}}
          </Btn>
        </div>
      </div>
    </pageWrapper>
  </transition>
</template>

<script>
  import pageWrapper from '~/components/common/pageWrapper';
  import PinCode from './Panel';
  import Btn from '~/components/UI/BtnSign_plain';
  import notification from '~/components/UI/notification';
  import info from '~/components/common/info';

  export default {
    name: "index",
    data() {
      return {
        animation: 'slideTo-left',
        disabled: true,
        title: '',
        oldPin: null,
        hasError: false,
        hasEncryptedPrivate: localStorage.getItem('encryptedPrivate')
      }
    },
    components: {
      pageWrapper,
      PinCode,
      Btn,
      info
    },
    computed: {
      needToReenter() {
        return this.hasEncryptedPrivate && this.controls;
      },
      navs() {
        return this.$store.state.pincode.navs;
      },
      controls() {
        return this.$store.state.pincode.controls;
      },
      show() {
        const show = this.$store.state.pincode.show;
        this.hasEncryptedPrivate = localStorage.getItem('encryptedPrivate');
        if (this.needToReenter) {
          this.title = this.$t('pincode.old');
        } else {
          this.title = this.$t('pincode.title');
        }
        if (!show) this.disabled = true;
        return show;
      }
    },
    methods: {
      skip() {
        this.$store.dispatch('user/login');
        this.closeAll();
      },
      closeAll() {
        this.close();
        this.$root.$refs['headerTop'].openMenu(false, true);
      },
      close() {
        this.$store.commit('pincode/SET_SHOW_PINCODE', {controls: true, show: false});
        this.$root.$refs['headerTop'].openMenu(true);
      },
      decryptPrivate(values) {
        return new Promise((resolve, reject) => {
          this.disabled = true;
          this.$store.dispatch('pincode/decrypt', {
            pin: values
          }).then(key => {
            const matched = key.match(/[a-zA-Z1-9]/gi);
            if (!matched || matched.length < 51) {
              this.disabled = true;
              this.hasError = true;
              setTimeout(_ => {
                this.$refs['pincode'].clear();
              }, 800);
              reject();
              return
            }
            this.$store.commit('wallet/SET_PRIVATE_KEY', key);
            //localStorage.setItem('private', key);
            localStorage.removeItem('pincode');
            localStorage.removeItem('encryptedPrivate');
            this.hasEncryptedPrivate = false;
            this.disabled = false;
            this.$refs['pincode'].clear();
            resolve();
          });
        })
      },
      encrypt(values) {
        this.disabled = true;
        this.$store.dispatch('pincode/encrypt', {
          pin: values
        }).then(_ => {
          this.close();
          this.hasEncryptedPrivate = true;
          this.$store.dispatch('user/login');
        });
      },
      lock(values) {
        this.$store.dispatch('pincode/lock', {
          pin: values
        });
      },
      unlock(values) {
        const controls = this.controls;
        this.$store.dispatch('pincode/unlock', {
          pin: values
        }).then(res => {
          !controls && this.$emit('setLoader');
        }).catch(err => {
          this.hasError = true;
          setTimeout(_ => {
            this.$refs['pincode'].clear();
          }, 800);
        });
      },
      submit() {
        const values = Object.values(this.$refs['pincode'].values).join('');
        if (this.needToReenter) {
          this.decryptPrivate(values).then(res => {
            this.title = '4 Digit pin code';
          });
        } else {
          this.encrypt(values);
        }
      },
      onChange(values) {
        this.hasError = false;
        if (values.length === 4) {
          this.disabled = false;
          if (localStorage.getItem('pincode') === 'true' && !this.controls) this.unlock(values);
        } else {
          this.disabled = true;
        }
      }
    }
  }
</script>
